﻿using System.Collections.Generic;
using System.IO;
using System.Web;
using System.Web.Mvc;
using Telerik.Web.Mvc.UI;
using Uco.Infrastructure;

namespace Uco.Areas.Admin.Controllers
{
    [Authorize]
    public partial class UploadController : Controller
    {
        public ActionResult Save(IEnumerable<HttpPostedFileBase> attachments)
        {
            foreach (var file in attachments)
            {
                var fileName = Path.GetFileName(file.FileName);
                var physicalPath = Path.Combine(Server.MapPath("~/Content/UserFiles/Upload"), fileName);
                file.SaveAs(physicalPath);
            }
            return Content("");
        }
        public ActionResult Remove(string[] fileNames)
        {
            foreach (var fullName in fileNames)
            {
                var fileName = Path.GetFileName(fullName);
                var physicalPath = Path.Combine(Server.MapPath("~/Content/UserFiles/Upload"), fileName);
                if (System.IO.File.Exists(physicalPath))
                {
                    System.IO.File.Delete(physicalPath);
                }
            }
            return Content("");
        }

        public ActionResult SaveApp_Data(IEnumerable<HttpPostedFileBase> attachments)
        {
            string WorkFolder = "~/App_Data/exercises/";
            string WorkFolderPath = Server.MapPath(WorkFolder);
            foreach (var file in attachments)
            {
                var fileName = Path.GetFileName(file.FileName);
                var physicalPath = Path.Combine(WorkFolderPath, fileName);
                file.SaveAs(physicalPath);
            }
            return Content("");
        }

        public ActionResult RemoveApp_Data(string[] fileNames)
        {
            string WorkFolder = "~/App_Data/exercises/";
            string WorkFolderPath = Server.MapPath(WorkFolder);
            foreach (var fullName in fileNames)
            {
                var fileName = Path.GetFileName(fullName);
                var physicalPath = Path.Combine(WorkFolderPath, fileName);
                if (System.IO.File.Exists(physicalPath))
                {
                    System.IO.File.Delete(physicalPath);
                }
            }
            return Content("");
        }
    }
}