﻿using System.Collections.Generic;
using System.IO;
using System.Web;
using System.Web.Mvc;
using Telerik.Web.Mvc.UI;

namespace Uco.Controllers
{
    [Authorize]
    public partial class GalleryController : Controller
    {
        public ActionResult Save(IEnumerable<HttpPostedFileBase> attachments, string name)
        {
            string UserFolder = "~/Content/UserFiles/" + name + "/";
            string UserFolderPath = Server.MapPath(UserFolder);
            CreateUserFolder(UserFolderPath);
            foreach (var file in attachments)
            {
                var fileName = Path.GetFileName(file.FileName);
                var physicalPath = Path.Combine(UserFolderPath, fileName);
                file.SaveAs(physicalPath);
            }
            return Content("");
        }

        public ActionResult Remove(string[] fileNames, string name)
        {
            string UserFolder = "~/Content/UserFiles/" + name + "/"; ;
            string UserFolderPath = Server.MapPath(UserFolder);
            CreateUserFolder(UserFolderPath);
            foreach (var fullName in fileNames)
            {
                var fileName = Path.GetFileName(fullName);
                var physicalPath = Path.Combine(UserFolderPath, fileName);
                if (System.IO.File.Exists(physicalPath))
                {
                    System.IO.File.Delete(physicalPath);
                }
            }
            return Content("");
        }

        public ActionResult RemoveFile(string fullName, string name)
        {
            string folder = "/image?img=/content%2fuserfiles%2f" + Server.UrlEncode(name + "/");
            folder = folder.ToLower();
            fullName = fullName.ToLower();
            if (!fullName.Contains(folder)) throw new HttpException(500, "error");
            string file = fullName.Replace(folder, "");
            if (!file.Contains("&w=")) throw new HttpException(500, "error");
            file = file.Remove(file.IndexOf("&w="));
            string UserFolder = "~/Content/UserFiles/" + name + "/";
            string UserFolderPath = Server.MapPath(UserFolder);
            CreateUserFolder(UserFolderPath);
			file = Server.UrlDecode(file);
            var physicalPath = Path.Combine(UserFolderPath, file);
            if (System.IO.File.Exists(physicalPath))
            {
                System.IO.File.Delete(physicalPath);
                return Content("");
            }
            else throw new HttpException(500, "error");
        }

        private void CreateUserFolder(string UserFolderPath)
        {
            if (Directory.Exists(UserFolderPath)) return;
            DirectoryInfo di = Directory.CreateDirectory(UserFolderPath);
        }
    }
}