﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Uco.Models;
using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;
using Uco.Infrastructure;

namespace Uco.Models
{
    public class ContactSmallForm
    {
        [Display(Name = "Name", Order = 20, ResourceType = typeof(Uco.Content.Resources.SystemModels))]
        [Required(ErrorMessageResourceName = "NameRequired", ErrorMessageResourceType = typeof(Uco.Content.Resources.SystemModels))]
        public string ContactName { get; set; }

        [Display(Name = "Email", Order = 30, ResourceType = typeof(Uco.Content.Resources.SystemModels))]
        [Email(ErrorMessageResourceName = "EmailNotValid", ErrorMessageResourceType = typeof(Uco.Content.Resources.SystemModels))]
        public string ContactEmail { get; set; }

        [Display(Name = "Phone", Order = 40, ResourceType = typeof(Uco.Content.Resources.SystemModels))]
        [Required(ErrorMessageResourceName = "PhoneRequired", ErrorMessageResourceType = typeof(Uco.Content.Resources.SystemModels))]
        [Phone(ErrorMessageResourceName = "PhoneNotValid", ErrorMessageResourceType = typeof(Uco.Content.Resources.SystemModels))]
        public string ContactPhone { get; set; }
    }
    public class ContactForm
    {
        [Display(Name = "Name", Order = 20, ResourceType = typeof(Uco.Content.Resources.SystemModels))]
        [Required(ErrorMessageResourceName = "NameRequired", ErrorMessageResourceType = typeof(Uco.Content.Resources.SystemModels))]
        public string ContactName { get; set; }

        [Display(Name = "Email", Order = 30, ResourceType = typeof(Uco.Content.Resources.SystemModels))]
        [Email(ErrorMessageResourceName = "EmailNotValid", ErrorMessageResourceType = typeof(Uco.Content.Resources.SystemModels))]
        public string ContactEmail { get; set; }

        [Display(Name = "Phone", Order = 40, ResourceType = typeof(Uco.Content.Resources.SystemModels))]
        [Required(ErrorMessageResourceName = "PhoneRequired", ErrorMessageResourceType = typeof(Uco.Content.Resources.SystemModels))]
        [Phone(ErrorMessageResourceName = "PhoneNotValid", ErrorMessageResourceType = typeof(Uco.Content.Resources.SystemModels))]
        public string ContactPhone { get; set; }

        [Display(Name = "פניה", Order = 50)]
        [DataType(DataType.MultilineText)]
        public string ContactData { get; set; }
    }
}