﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;
using System.Data.Entity;
using System.Web.Mvc;
using System.ComponentModel;
using System.Data.Objects;
using System.Data.EntityClient;
using Uco.Infrastructure;

namespace Uco.Models
{

    public class AbstractPageBinder : DefaultModelBinder
    {
        protected override object CreateModel(
            ControllerContext controllerContext,
            ModelBindingContext bindingContext,
            Type modelType)
        {
            ValueProviderResult result;
            result = bindingContext.ValueProvider.GetValue("RouteUrl");
            if (result == null) throw new NotImplementedException("RouteUrl must be specified");

            foreach (Type item in SF.GetAbstractPageChildClasses())
            {
                if (result.AttemptedValue == SF.GetTypeRouteUrl(item))
                {
                    var model = Activator.CreateInstance(item);
                    bindingContext.ModelMetadata = ModelMetadataProviders.Current.GetMetadataForType(() => model, item);
                    return model;
                }
            }
            
            throw new NotImplementedException("RouteUrl must be specified");
        }
    }


}